﻿using MVCSampleBrowser.Models;
using Syncfusion.JavaScript.DataSources;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using Syncfusion.Linq;
using System.Web;
using System.Web.Mvc;
using Syncfusion.JavaScript.Models;
using System.Web.Script.Serialization;
using System.Reflection;
using System.Dynamic;
using System.Data;
using Syncfusion.EJ.Export;
using Syncfusion.XlsIO;

namespace MvcApplication66.Controllers
{
    public class HomeController : Controller
    {
        List<Order> or = new List<Order>();
        public ActionResult Index(){
            ViewBag.dataSource = OrderRepository.GetAllRecords().ToList();
            return View();
        }
        public void ExportToExcel(string GridModel)
        {
            ExcelExport exp = new ExcelExport();
            var DataSource = new NorthwindDataContext().OrdersViews.Take(100).ToList();
            GridProperties obj = ConvertGridObject(GridModel);
            exp.Export(obj, DataSource, "Export.xlsx", ExcelVersion.Excel2010, false, false, "flat-saffron");
        }
        //public void ExportToWord(string GridModel)
        //{
        //    WordExport exp = new WordExport();
        //    var DataSource = new NorthwindDataContext().OrdersViews.Take(100).ToList();
        //    GridProperties obj = ConvertGridObject(GridModel);
        //    exp.Export(obj, DataSource, "Export.docx", false, false, "flat-saffron");
        //}
        //public void ExportToPdf(string GridModel)
        //{
        //    PdfExport exp = new PdfExport();
        //    var DataSource = new NorthwindDataContext().OrdersViews.Take(100).ToList();
        //    GridProperties obj = ConvertGridObject(GridModel);
        //    exp.Export(obj, DataSource, "Export.pdf", false, false, "flat-saffron");
        //}
        private GridProperties ConvertGridObject(string gridProperty)
        {
            JavaScriptSerializer serializer = new JavaScriptSerializer();
            IEnumerable div = (IEnumerable)serializer.Deserialize(gridProperty, typeof(IEnumerable));
            GridProperties gridProp = new GridProperties();
            foreach (KeyValuePair<string, object> ds in div)
            {
                var property = gridProp.GetType().GetProperty(ds.Key, BindingFlags.Instance | BindingFlags.Public | BindingFlags.IgnoreCase);
                if (property != null)
                {
                    Type type = property.PropertyType;
                    string serialize = serializer.Serialize(ds.Value);
                    object value = serializer.Deserialize(serialize, type);
                    property.SetValue(gridProp, value, null);
                }
            }
            return gridProp;
        }

        public ActionResult Update(EditableOrder value)
        {
            OrderRepository.Update(value);
            return Json(value, JsonRequestBehavior.AllowGet);
        }
        public ActionResult Insert(EditableOrder value)
        {
            OrderRepository.Add(value);
            return Json(value, JsonRequestBehavior.AllowGet);
        }
        public ActionResult Delete(int key)
        {
            OrderRepository.Delete(key);
            var data = OrderRepository.GetAllRecords();
            return Json(data, JsonRequestBehavior.AllowGet);
        }
    }
}